//+------------------------------------------------------------------+
//|                                               2cci_bearbulls.mq4 |
//|                                        Copyright  2008, masemus |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, masemus"
#property link      "masemus@yahoo.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Silver
#property indicator_color4 Gray
#property indicator_color5 Red

#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 2
#property indicator_width5 1

#property indicator_level1 100
#property indicator_level2 -100

#property indicator_levelcolor Silver
#property indicator_levelstyle STYLE_DOT

extern int BearBulls = 13;
extern int CCI_1 = 2;
extern int CCI_2 = 5;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double Bears0;
double Bulls0;
double CCI01;
double CCI02;
double CCIBuffer1[];
double CCIBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators
  SetIndexStyle(0,DRAW_HISTOGRAM);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexStyle(1,DRAW_HISTOGRAM);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexStyle(2,DRAW_HISTOGRAM);
  SetIndexBuffer(2,ExtMapBuffer3);
  SetIndexStyle(3,DRAW_LINE);
  SetIndexBuffer(3,CCIBuffer1);
  SetIndexStyle(4,DRAW_LINE);
  SetIndexBuffer(4,CCIBuffer2);

  SetIndexLabel(0,NULL);
  SetIndexLabel(1,NULL);
  SetIndexLabel(2,NULL);
  SetIndexLabel(3,NULL);
  SetIndexLabel(4,NULL);

   IndicatorShortName("2cci_bearbulls");  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- 
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int i=0; i<limit; i++)
      CCIBuffer1[i]=iCCI(NULL,0,CCI_1,PRICE_TYPICAL,i);
   for( i=limit; i>=0; i--)
   {
      CCIBuffer2[i]=iCCI(NULL,0,CCI_2,PRICE_TYPICAL,i);

   ExtMapBuffer1[i]=0;
   ExtMapBuffer2[i]=0;
   ExtMapBuffer3[i]=-1;
 
   Bears0=iBearsPower(NULL,0,BearBulls,PRICE_TYPICAL,i);
   Bulls0=iBullsPower(NULL,0,BearBulls,PRICE_TYPICAL,i);
   CCI01=iCCI(NULL,0,CCI_1,PRICE_TYPICAL,i);
   CCI02=iCCI(NULL,0,CCI_2,PRICE_TYPICAL,i);

     if (CCI01<CCI02 && Bulls0>=0 && CCI01>=0 && CCI02>=0) {ExtMapBuffer1[i]=20;}
     else if (CCI01>CCI02 && Bears0<=0 && CCI01<=0 && CCI02<=0) {ExtMapBuffer2[i]=-20;}
          else {ExtMapBuffer3[i]=1;}

   }



//----
   return(0);
  }
//+------------------------------------------------------------------+

